#include <iostream>
#include <memory>
#include "e.h"
#include "eparse.h"

using namespace std;

int
main() {
	Parser *parser = 0;
	try {
		parser = new ExprParser( new ExprLex );
		while( true ) {
			cout << "Podaj wyraenie:  " << flush;
			auto_ptr<E> root( parser->parse() );
			if( !root.get() )
				break;
			cout << "Wynik: " << root->eval() << endl;
		}
	}
	catch( const exception &e ) {
		cout << "***" << e.what() << "***" << endl;
	}
	catch( ... ) {
		cout << "pojawi si wyjtek" << endl;
	}
	delete parser;

	return 0;
}
